SUB Benchmark.1(faktor1!)
LOCAL i, elapsedtime!
  PRINT "Benchmark 1:       "
  PRINT "  Integerarithmetik: ";
  i = 0  :  MTIMER
  DO
    i = i + 1
  LOOP UNTIL i = 30000
  DO
    i = i - 1
  LOOP UNTIL i = 0
  i = 2
  DO WHILE i <= 15000
    i = i*2
  LOOP
  DO
    i = i\2
  LOOP UNTIL i <= 10
  elapsedtime! = MTIMER/1E6
  PRINT USING"     ##.##"; ElapsedTime!;
  PRINT " sec. (IBM-XT ca.  5.92 sec.)";
  IF elapsedtime! > 0 THEN
    faktor1! = 592/elapsedtime!
    PRINT USING "  Faktor: ####.# %"; faktor1!
  END IF
END SUB

SUB Benchmark.2(faktor2!)
LOCAL i#, elapsedtime!
  i# = 2
  PRINT "Benchmark 2: "
  PRINT "  Realarithmetik:";
  MTIMER
  DO
    i# = i#*i#
  LOOP UNTIL i# >= 1E31
  DO
    i# = i#/2
  LOOP UNTIL i# <= 0
  i# = 2
  DO
    i# = i# ^ 1.5
  LOOP UNTIL i# >= 1E31
  elapsedtime! = MTIMER/1E6
  PRINT USING"        ##.##"; elapsedTime!;
  PRINT " sec. (IBM-XT ca.  5.11 sec.)";
  IF elapsedtime! > 0 THEN
    faktor2! = 511/elapsedtime!
    PRINT USING "  Faktor: ####.# %"; faktor2!
  END IF
END SUB

SUB Benchmark.3(faktor3!)
LOCAL a$, elapsedtime!
  PRINT "Benchmark 3:"
  PRINT "  Stringmanipulationen:";
  MTIMER  :  a$=""
  DO
    a$ = a$ + "i"
  LOOP UNTIL LEN(a$) >= 2000
  DO
    a$ = LEFT$(a$, LEN(a$) - 1)
  LOOP UNTIL LEN(a$) <= 10
  elapsedtime! = MTIMER/1E6
  PRINT USING "  ##.##"; ElapsedTime!;
  PRINT " sec. (IBM-XT ca. 19.29 sec.)";
  IF elapsedtime! > 0 THEN
    faktor3! = 1929/elapsedtime!
    PRINT USING "  Faktor: ####.# %"; faktor3!
  END IF
END SUB

SUB Benchmark
LOCAL gesamtfaktor!
  CALL SubMen("Speed-Test")
  CALL QPrint(7, 1, " Bitte warten !", 143)
  DELAY 1               ' Eventuelles Tastendrcken abwarten
  LOCATE 7,1  :  COLOR 7,0
  CALL Benchmark.1(faktor1!)  :  PRINT
  CALL Benchmark.2(faktor2!)  :  PRINT
  CALL Benchmark.3(faktor3!)  :  PRINT
  gesamtfaktor! = (faktor1! + faktor2! + faktor3!) / 3
  PRINT  :  PRINT  :  COLOR 15,0
  PRINT "Berechnung des Durchschnittwertes:"
  PRINT "  Gesamtfaktor (Vergleich mit IBM-XT";
  PRINT " INTEL 8088, 4,77 MHz): ";
  PRINT USING "####.# %"; Gesamtfaktor!
  COLOR 7,0
END SUB
